package org.caosdb.server.database.backend.transaction;

import org.caosdb.server.database.BackendTransaction;
import org.caosdb.server.database.backend.interfaces.ListFilesImpl;
import org.caosdb.server.filesystem.FileStorageInterface;
import org.caosdb.server.filesystem.Path;
import org.caosdb.server.filesystem.VirtualFSODescriptorInterface;

@Deprecated
public class ListFilesTransaction extends BackendTransaction {

  private Path path;
  private Long lastChecked;
  private String fileStorageId;
  private Iterable<VirtualFSODescriptorInterface> files;
  private Integer limit;

  public ListFilesTransaction(
      FileStorageInterface fileStorage, Path path, Long lastChecked, Integer limit) {
    this(fileStorage.getId(), path, lastChecked, limit);
  }

  public ListFilesTransaction(String fileStorageId, Path path, Long lastChecked, Integer limit) {
    this.fileStorageId = fileStorageId;
    this.path = path;
    this.lastChecked = lastChecked;
    this.limit = limit;
  }

  public Iterable<VirtualFSODescriptorInterface> getFiles() {
    return files;
  }

  @Override
  protected void execute() {
    ListFilesImpl t = getImplementation(ListFilesImpl.class);
    files = t.execute(fileStorageId, path, lastChecked, limit);
  }
}
